import * as _ from "lodash";
import { BaseAction, BaseActionProps, BaseActionState } from "./BaseAction";

export interface CoursesFetcherProps extends BaseActionProps {}

export interface CoursesFetcherState extends BaseActionState {}

export class CoursesFetcher<
	P extends CoursesFetcherProps = CoursesFetcherProps,
	S extends CoursesFetcherState = CoursesFetcherState
> extends BaseAction<P, S> {
	constructor(props: P) {
		super(props);

		this.fetchCourses = this.fetchCourses.bind(this);
	}

	public componentDidMount() {
		this.fetchCourses();
	}

	public fetchCourses() {
		const { store } = this;
		const { courseState } = store;
		const { courses } = courseState;

		if (_.isNil(courses.value) && !courses.isLoading) {
			courseState.fetchCourses().then(response => response);
		}
	}
}
