import * as _ from "lodash";
import { BaseAction, BaseActionProps, BaseActionState } from "./BaseAction";

export interface UpdatesFetcherProps extends BaseActionProps {}

export interface UpdatesFetcherState extends BaseActionState {}

export class UpdatesFetcher<
	P extends UpdatesFetcherProps = UpdatesFetcherProps,
	S extends UpdatesFetcherState = UpdatesFetcherState
> extends BaseAction<P, S> {
	public componentDidMount() {
		const { store } = this;
		const { updateState } = store;
		const { updates } = updateState;

		if (_.isNil(updates.value) && !updates.isLoading) {
			updateState.fetchUpdates({});
		}
	}
}
