import axios, { AxiosResponse } from "axios";
import isNil from "lodash/isNil";

export interface BaseRequest {
	options?: any;
}

export interface BaseResponse extends AxiosResponse {
	success: boolean;
}

export class Base {
	protected static axios = axios;

	protected static processResponse<T extends BaseResponse>(
		request: BaseRequest,
		result: AxiosResponse
	): T {
		const response: any = {
			...result,
			success:
				!isNil(result) && result.status >= 200 && result.status < 300
		};

		return response;
	}
}
