import isNil from "lodash/isNil";
import * as Models from "../../models";
import { Base, BaseResponse } from "./Base";

export class FAQ extends Base {
	public static async fetchFAQs(): Promise<FetchFAQsResponse> {
		const { axios } = this;

		return axios
			.get<FetchFAQsResponse>(`https://open.fing.edu.uy/data/faq.json`)
			.then(httpResponse => {
				const response = this.processResponse<FetchFAQsResponse>(
					{},
					httpResponse
				);

				response.faqs =
					isNil(httpResponse.data) || isNil(httpResponse.data.faqs)
						? []
						: httpResponse.data.faqs.map((faq: any) =>
								Models.FAQ.fromJSON(faq)
						  );

				return response;
			});
	}
}

export interface FetchFAQsResponse extends BaseResponse {
	faqs: Models.FAQ[];
}
