import isNil from "lodash/isNil";
import * as Models from "../../models";
import { Base, BaseRequest, BaseResponse } from "./Base";

export class Update extends Base {
	public static async fetchUpdates(
		request: FetchUpdatesRequest
	): Promise<FetchUpdatesResponse> {
		const { axios } = this;

		return axios
			.get(`https://open.fing.edu.uy/data/Updates.json`)
			.then(httpResponse => {
				const response = this.processResponse<FetchUpdatesResponse>(
					request,
					httpResponse
				);

				response.updates =
					isNil(httpResponse.data) || isNil(httpResponse.data.updates)
						? []
						: httpResponse.data.updates.map((course: any) =>
								Models.Update.fromJSON(course)
						  );

				return response;
			});
	}
}

export interface FetchUpdatesRequest extends BaseRequest {}

export interface FetchUpdatesResponse extends BaseResponse {
	updates: Models.Update[];
}
