import * as _ from "lodash";
import { BaseModel } from "./BaseModel";
import { CourseClass } from "./CourseClass";

export class Course extends BaseModel {
	public static getIconURLsFromCode(code: string) {
		return ["svg", "png"].map(
			suffix =>
				`https://open.fing.edu.uy/Images/iconCourse/${code}_image.${suffix}`
		);
	}

	public static fromJSON(json: any): Course {
		const object = new Course();

		_.assign(object, super.fromJSON(json));
		const imageURL = `https://open.fing.edu.uy/Images/iconCourse/${
			json.code
		}_image`;

		if (!_.isNil(json.classes)) {
			_.assign(object, {
				classes: CourseClass.arrayFromJSON(json.classes, object),
				iconURLs: this.getIconURLsFromCode(json.code)
			});
		}

		return object;
	}

	public code: string;
	public eva: string;
	public name: string;
	public classes: CourseClass[];
	public iconURLs: string[];
}
