import assign from "lodash/assign";
import { BaseModel } from "./BaseModel";
import { Course } from "./Course";

export class CourseClass extends BaseModel {
	public static fillWithZeros(classNo: number, minLength: number): string {
		const array = Array.from(classNo.toString());

		return new Array(Math.max(0, minLength - array.length))
			.fill(undefined)
			.map(() => "0")
			.concat(array)
			.join("");
	}

	public static arrayFromJSON(json: any, course: Course): CourseClass[] {
		return Object.keys(json).map(k => {
			const courseClass = new CourseClass();

			const videoURL = `http://openfing-video.fing.edu.uy/media/
			${course.code}/${course.code}_${this.fillWithZeros(Number(k), 2)}`;

			assign(courseClass, {
				code: Number(k),
				title: json[k],
				videoURLs: [".mp4", ".webm"].map(suffix => videoURL + suffix)
			});

			return courseClass;
		});
	}

	public code: number;
	public title: string;
	public videoURLs: string[];
}
